//******************************************************************************
//  Studienarbeit, 5. Semester
//
//
//Diese Software wird auf den Controller vom Typ "MSP430G2302" geflasht und stellt
//grundlegende Funktionen fr die whrend der Studienarbeit entstandene Platine bereit.
//Display, Temperatur- und Feuchtesensor, RTC und EEPROM knnen
//ber I2C angesprochen werden.
//
//Zur Kommunikation ber I2C wird die USI Bibliothek von TI benutzt.
//
//
//
//
//
//
//
//
//
//  
//  November 2011
//  Built with IAR Assembler for MSP430 5.30.1
//******************************************************************************



//defines
#define UPDATE_RTC //Wenn eine neue Uhrzeit in der RTC eingestellt werden soll, muss die Kommentierung entfernt werden.


//includes
#include  "msp430g2302.h"



#include  "CLOCKS.h"
#include  "I2C.h"
#include  "RTC.h"
#include  "LCD.h"
#include  "EEPROM.h"
#include  "HYG.h"




//globale Variablen
const char LCD_ADDR    = 0x3A;
char RTC_ADDR    = 0x68;
const char EEPROM_ADDR = 0x50;
const char HYG_ADDR    = 0x28;

unsigned char old_sec = 0; 
unsigned char n_sec = 0;   //Vergangene Sekdunden seit der letzten Datenspeicherung

unsigned char timeDate[] = {
    0x00, //Sekunden
    0x00, //Minuten
    0x00, //Stunden
    
    0x00, //Wochentag (1=Montag, 2=Dienstag...
    0x00, //Tag
    0x00, //Monat
    0x00 //Jahr
};

char datensatz[2] = {
  0x00, //Feuchte
  0x00, //Temperatur
};



void main(void)
{
  
  WDTCTL = WDTPW + WDTHOLD;                   //! Watchdogtimer ausschalten
  
  InitializeClocks();
  InitI2C();
  //CheckI2CSlaves();
  
  InitLCD();
  
  LCDwrite("1. Zeile", 8,1);
  LCDwrite("2. Zeile", 8,2);
  LCDwrite("3. Zeile", 8,3);
  
  LCDwrite("1.", 3,1);
  LCDappend("Hallo Welt", 10);
  
  
 #ifdef UPDATE_RTC
  UpdateRTC();
 #endif

  



  while(1){
    
    
    GetTimeDate(timeDate);
    old_sec = timeDate[0];
    while(old_sec == timeDate[0]){   //Endlosschleife bis RTC einen neuen Sekundenwert liefert
      GetTimeDate(timeDate);
    }
   
    ReadHygTemp(datensatz);         // Messwerte in datensatz speicher

    

  
    //an dieser Stelle sollen die beiden Werte auf dem Display ausgegeben werden
    
    if(n_sec == 23) //Wenn eine gewisse Zeit abgelaufen ist
    {
      WriteEEPROM(datensatz, 2);
      n_sec = 0 ;
    }
    else
      n_sec++;
    
    }
  
}







  











 






